<div class="card">
  <h4 class="card-header">Register</h4>
  <div class="card-body">
    <form [formGroup]="form" (ngSubmit)="onSubmit()">
      <div class="mb-3">
        <label for="firstName" class="form-label">First Name</label>
        <input type="text" formControlName="firstName" class="form-control"
          [ngClass]="{ 'is-invalid': submitted && f.firstName.errors }" />
        <div *ngIf="submitted && f.firstName.errors" class="invalid-feedback">
          <div *ngIf="f.firstName.errors.required">First Name is required</div>
          <div *ngIf="f.firstName.errors.minlength">FirstName must be at least 5 characters</div>
          <div *ngIf="f.firstName.errors.maxlength">FirstName must be less than 50 characters</div>
        </div>
      </div>
      <div class="mb-3">
        <label for="lastName" class="form-label">Last Name</label>
        <input type="text" formControlName="lastName" class="form-control"
          [ngClass]="{ 'is-invalid': submitted && f.lastName.errors }" />
        <div *ngIf="submitted && f.lastName.errors" class="invalid-feedback">
          <div *ngIf="f.lastName.errors.required">Last Name is required</div>
          <div *ngIf="f.lastName.errors.minlength">LastName must be at least 5 characters</div>
          <div *ngIf="f.lastName.errors.maxlength">LastName must be less than 50 characters</div>
        </div>
      </div>
      <div class="mb-3">
        <label for="username" class="form-label">Username</label>
        <input type="text" formControlName="username" class="form-control"
          [ngClass]="{ 'is-invalid': submitted && f.username.errors }" />
        <div *ngIf="submitted && f.username.errors" class="invalid-feedback">
          <div *ngIf="f.username.errors.required">Username is required</div>
          <div *ngIf="f.username.errors.minlength">Username must be at least 5 characters</div>
          <div *ngIf="f.username.errors.maxlength">Username must be less than 50 characters</div>
        </div>
      </div>
      <div class="mb-3">
        <label for="password" class="form-label">Password</label>
        <input type="password" formControlName="password" class="form-control"
          [ngClass]="{ 'is-invalid': submitted && f.password.errors }" />
        <div *ngIf="submitted && f.password.errors" class="invalid-feedback">
          <div *ngIf="f.password.errors.required">Password is required</div>
          <div *ngIf="f.password.errors.minlength">Password must be at least 5 characters</div>
          <div *ngIf="f.password.errors.maxlength">Password must be less than 50 characters</div>
        </div>
      </div>
      <div class="mb-3">
        <button [disabled]="loading" class="btn btn-primary">
          <span *ngIf="loading" class="spinner-border spinner-border-sm mr-1"></span>
          Register
        </button>
        <a routerLink="../login" class="btn btn-link">Cancel</a>
      </div>
    </form>
    <div class="alert alert-warning" *ngIf="warningMessage">{{warningMessage}}</div>
  </div>
</div>